"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/styled.tsx
var styled_exports = {};
__export(styled_exports, {
  createStyled: () => createStyled,
  css: () => css
});
module.exports = __toCommonJS(styled_exports);
var import_vue = require("vue");
var import_clsx = __toESM(require("clsx"));
var import_vue2 = require("vue");
var import_serialize = require("@emotion/serialize");
var import_vue_utils3 = require("@chakra-ui/vue-utils");
var import_utils2 = require("@emotion/utils");
var import_lodash = __toESM(require("lodash.camelcase"));

// src/cache.tsx
var import_cache = __toESM(require("@emotion/cache"));
var import_vue_utils = require("@chakra-ui/vue-utils");
function createCache(...args) {
  return typeof import_cache.default === "function" ? (0, import_cache.default)(...args) : import_cache.default.default(...args) ? import_cache.default.default(...args) : (0, import_cache.default)(...args);
}
__name(createCache, "createCache");
var [EmotionCacheProvider, useEmotionCache, EmotionCacheInjectionSymbol] = (0, import_vue_utils.createContext)({
  strict: false,
  name: "EmotionCacheContext"
});
var defaultCache = createCache({
  key: "chakra"
});
var __unusafe_useEmotionCache = useEmotionCache;
var withEmotionCache = /* @__PURE__ */ __name(function withEmotionCache2(fn) {
  return (p) => {
    const cache = useEmotionCache(defaultCache);
    return fn(cache);
  };
}, "withEmotionCache");
if ((0, import_vue_utils.canUseDOM)()) {
  withEmotionCache = /* @__PURE__ */ __name(function withEmotionCache3(fn) {
    return () => {
      const cache = useEmotionCache(defaultCache);
      if (!cache) {
        const cache2 = createCache({
          key: "chakra"
        });
        EmotionCacheProvider(cache2);
        return fn(cache2);
      } else {
        return fn(cache);
      }
    };
  }, "withEmotionCache");
}

// src/theming.tsx
var import_weak_memoize = __toESM(require("@emotion/weak-memoize"));
var import_vue_utils2 = require("@chakra-ui/vue-utils");
var [_EmotionThemeProvider, useEmotionTheme, EmotionThemeContextSymbol] = (0, import_vue_utils2.createContext)({
  strict: false,
  name: "EmotionThemeContext"
});

// src/styled.tsx
var import_lodash2 = __toESM(require("lodash.memoize"));
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !(0, import_vue.isVNode)(s);
}
__name(_isSlot, "_isSlot");
var ILLEGAL_ESCAPE_SEQUENCE_ERROR = `You have illegal escape sequence in your template literal, most likely inside content's property value.
Because you write your CSS inside a JavaScript string you actually have to do double escaping, so for example "content: '\\00d7';" should become "content: '\\\\00d7';".
You can read more about this here:
https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Template_literals#ES2018_revision_of_illegal_escape_sequences`;
var isBrowser = typeof document !== "undefined";
var Noop = /* @__PURE__ */ __name(() => null, "Noop");
var camelCaseCache = {};
var _camelCase = (0, import_lodash2.default)((key) => (0, import_lodash.default)(key));
var createStyled = /* @__PURE__ */ __name((tag, options) => {
  if (process.env.NODE_ENV !== "production") {
    if (tag === void 0) {
      throw new Error("You are trying to create a styled element with an undefined component.\nYou may have forgotten to import it.");
    }
  }
  const isReal = tag.__emotion_real === tag;
  const baseTag = isReal && tag.__emotion_base || tag;
  let identifierName;
  let targetClassName;
  if (options !== void 0) {
    identifierName = options.__label;
    targetClassName = options.target;
  }
  return function() {
    let args = arguments;
    let styles = isReal && tag.__emotion_styles !== void 0 ? tag.__emotion_styles.slice(0) : [];
    if (identifierName !== void 0) {
      styles.push(`label:${identifierName};`);
    }
    if (args[0] == null || args[0].raw === void 0) {
      styles.push.apply(styles, args);
    } else {
      if (process.env.NODE_ENV !== "production" && args[0][0] === void 0) {
        console.error(ILLEGAL_ESCAPE_SEQUENCE_ERROR);
      }
      styles.push(args[0][0]);
      let len = args.length;
      let i = 1;
      for (; i < len; i++) {
        if (process.env.NODE_ENV !== "production" && args[0][i] === void 0) {
          console.error(ILLEGAL_ESCAPE_SEQUENCE_ERROR);
        }
        styles.push(args[i], args[0][i]);
      }
    }
    function StyledComponent(props, {
      attrs,
      expose,
      slots
    }) {
      const cache = __unusafe_useEmotionCache(defaultCache);
      const {
        as,
        ...restAttrs
      } = attrs || {};
      let mergedProps = {
        ...props,
        ...restAttrs
      };
      let className = (options == null ? void 0 : options.__label) ? `${cache.key}-${(options == null ? void 0 : options.__label) || typeof tag === "string" ? tag : "element"} ` : ``;
      const FinalTag = as || baseTag;
      const classInterpolations = [];
      mergedProps = {};
      for (let key in props) {
        if (camelCaseCache[key]) {
          mergedProps[key] = camelCaseCache[key];
        } else {
          const attr = _camelCase(key);
          camelCaseCache[attr] = props[key];
          mergedProps[attr] = props[key];
        }
      }
      if (props.theme == null) {
        mergedProps.theme = useEmotionTheme(void 0);
      }
      mergedProps = (0, import_vue2.mergeProps)({
        ...attrs,
        ...mergedProps
      });
      if (attrs.class) {
        className += (0, import_utils2.getRegisteredStyles)(cache.registered, classInterpolations, (0, import_clsx.default)(attrs.class));
      }
      const serialized = (0, import_serialize.serializeStyles)(styles.concat(classInterpolations), cache.registered, mergedProps);
      const rules = (0, import_utils2.insertStyles)(cache, serialized, typeof FinalTag === "string");
      className += `${cache.key}-${serialized.name}`;
      if (targetClassName !== void 0) {
        className += ` ${targetClassName}`;
      }
      const {
        attrs: htmlAttrs
      } = (0, import_vue_utils3.extractStyleAttrs)(mergedProps);
      const vnodeProps = {
        ...htmlAttrs,
        class: className
      };
      vnodeProps == null ? true : delete vnodeProps.theme;
      const StyledElement = (0, import_vue.createVNode)(FinalTag, vnodeProps, _isSlot(slots) ? slots : {
        default: () => [slots]
      });
      let possiblyStyleElement = (0, import_vue.createVNode)(Noop, null, null);
      if (!isBrowser && rules !== void 0) {
        let serializedNames = serialized.name;
        let next = serialized.next;
        while (next !== void 0) {
          serializedNames += " " + next.name;
          next = next.next;
        }
        possiblyStyleElement = (0, import_vue.createVNode)("style", {
          [`data-emotion`]: `${cache.key} ${serializedNames}`,
          nonce: cache.sheet.nonce
        }, [rules]);
      }
      return (0, import_vue.createVNode)(import_vue.Fragment, null, [possiblyStyleElement, StyledElement]);
    }
    __name(StyledComponent, "StyledComponent");
    StyledComponent._name = identifierName === void 0 ? `Styled${typeof baseTag === "string" ? baseTag : baseTag.name || "Component"}` : identifierName;
    StyledComponent.__emotion_real = StyledComponent;
    StyledComponent.__emotion_base = baseTag;
    StyledComponent.__emotion_styles = styles;
    Object.defineProperty(StyledComponent, "toString", {
      value() {
        if (targetClassName === void 0 && process.env.NODE_ENV !== "production") {
          return "NO_COMPONENT_SELECTOR";
        }
        return `.${targetClassName}`;
      }
    });
    StyledComponent.withComponent = (nextTag, nextOptions) => {
      return createStyled(
        nextTag,
        nextOptions === void 0 ? options : {
          ...options || {},
          ...nextOptions
        }
      ).apply(null, styles);
    };
    return StyledComponent;
  };
}, "createStyled");
function css(...args) {
  return (0, import_serialize.serializeStyles)(args, {});
}
__name(css, "css");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createStyled,
  css
});
